using System;
using System.Collections.Generic;
using System.Runtime.InteropServices;
using System.Text;

namespace GpioDotNet
{
    class NativeMethods
    {
        [DllImport("coredll.dll", EntryPoint = "CreateFile", SetLastError = true)]
        public static extern IntPtr CreateFile
        (
            String lpFileName,
            UInt32 dwDesiredAccess,
            UInt32 dwShareMode,
            IntPtr lpSecurityAttributes,
            UInt32 dwCreationDisposition,
            UInt32 dwFlagsAndAttributes,
            IntPtr hTemplateFile
        );

        [DllImport("Coredll.dll")]
        public static extern int CloseHandle(IntPtr handle);

        [DllImport("coredll.dll", SetLastError = true)]
        public static extern bool DeviceIoControl
        (
            IntPtr hDevice,
            uint dwIoControlCode,
            IntPtr lpInBuffer,
            uint nInBufferSize,
            IntPtr lpOutBuffer,
            uint nOutBufferSize,
            ref uint lpBytesReturned,
            IntPtr lpOverlapped
        );

        [DllImport("coredll.dll", SetLastError = true)]
        public static extern IntPtr CreateEvent(IntPtr lpEventAttributes, bool bManualReset, bool bInitialState, string lpName);

        [DllImport("coredll.dll", SetLastError = true)]
        public static extern Int32 WaitForSingleObject(IntPtr hHandle, UInt32 dwMilliseconds);

        public const UInt32 INFINITE = 0xFFFFFFFF;
        public const UInt32 OPEN_ALWAYS = 4;
     
        // IOCTL creation specific constants
        internal const uint METHOD_BUFFERED = 0;
        internal const uint FILE_WRITE_ACCESS = 0x0002;
        internal const uint FILE_DEVICE_UNKNOWN = 0x00000022;
        internal const uint FILE_ANY_ACCESS = 0;

        
        public static uint CTL_CODE_DEVICE_UNKNOWN(uint uiFunction)
        {
            return ((FILE_DEVICE_UNKNOWN << 16) | (FILE_ANY_ACCESS << 14) | ((uiFunction) << 2) | METHOD_BUFFERED);
        }
    }
}
