// SilverlightPlayerExample.cpp : Defines the entry point for the application.
//

#include "stdafx.h"
#include "SilverlightPlayerExample.h"
#include <windows.h>
#include <commctrl.h>

/* Relevant includes for the Silverlight applipcation */
#include "pwinuser.h"
#include "xamlruntime.h"
#include "xrdelegate.h"
#include "xrptr.h"

// Global Variables:
HINSTANCE			g_hInst;			// current instance
HWND				g_hWndCommandBar;	// command bar handle
IXRVisualHostPtr	g_vhost;			// XAML host - ned this to kill the App

// Global Defines



// Service routine
TCHAR*	GetSilverLightErrorString(HRESULT retcode)
{
	static TCHAR	pszUnknownMessage[50];
	static	TCHAR	pszErrorStrings[][50] =
	{
		{TEXT("XR_E_ABSTRACT_BASE_CLASS")},//0
		{TEXT("XR_E_COLLECTION_DUPLICATE_NAME")},//1
		{TEXT("XR_E_COLLECTION_ELEMENT_ALREADY_ASSOCIATED")},//2
		{TEXT("XR_E_DUPLICATE_REGISTRATION")},//3
		{TEXT("XR_E_ELEMENT_NOT_CREATED")},//4
		{TEXT("XR_E_ELEMENT_NOT_FOUND")},//5
		{TEXT("XR_E_INVALID_OBJECT")},//6
		{TEXT("XR_E_INVALID_PROPERTY")},//7
		{TEXT("XR_E_INVALID_ROOT_FOR_CREATING_HOST")},//8
		{TEXT("XR_E_INVALID_STATE")},//9
		{TEXT("XR_E_INVALID_THREAD_ACCESS")},//10
		{TEXT("XR_E_NOT_INITIALIZED")},//11
		{TEXT("XR_E_PARSER_ATTRIBUTE_OUT_OF_RANGE")},//12
		{TEXT("XR_E_PARSER_ATTRIBUTE_READONLY")},//13
		{TEXT("XR_E_PARSER_FAILED_RESOURCE_FIND")},//14
		{TEXT("XR_E_PARSER_INVALID_ATTRIBUTE")},//15
		{TEXT("XR_E_PARSER_INVALID_ATTRIBUTE_VALUE")},//16
		{TEXT("XR_E_PARSER_INVALID_CONTENT")},//17
		{TEXT("XR_E_PARSER_INVALID_PROPERTY")},//18
		{TEXT("XR_E_PARSER_MISSING_DEFAULT_NAMESPACE")},//19
		{TEXT("XR_E_PARSER_MULTIPLE_PROPERTY_ELEMENT_VALUES")},//20
		{TEXT("XR_E_PARSER_RESOURCE_KEY_AND_NAME_SET")},//21
		{TEXT("XR_E_PARSER_TEXT_CONTENT_UNSUPPORTED")},//22
		{TEXT("XR_E_PARSER_UNKNOWN_ATTRIBUTE")},//23
		{TEXT("XR_E_PARSER_UNKNOWN_ELEMENT")},//24
		{TEXT("XR_E_PARSER_UNKNOWN_NAMESPACE")},//25
		{TEXT("XR_E_STORYBOARD_BEGIN_ANIMATION_COMPOSITION")},//26
		{TEXT("XR_E_STORYBOARD_BEGIN_INCOMPATIBLE_TYPE")},//27
		{TEXT("XR_E_STORYBOARD_BEGIN_INVALID_KEYTIME")},//28
		{TEXT("XR_E_STORYBOARD_BEGIN_INVALID_PROPERTY")},//29
		{TEXT("XR_E_STORYBOARD_BEGIN_INVALID_TARGET")},//30
		{TEXT("XR_E_STORYBOARD_BEGIN_NO_TARGET")},//31
		{TEXT("XR_E_STORYBOARD_MODIFY_ACTIVE_ANIMATION")},//32
		{TEXT("XR_E_STORYBOARD_MUST_BE_ROOT ")},//33
		{TEXT("XR_E_STORYBOARD_SKIPTOFILL_NO_DURATION")}//34
	};

	switch(retcode)
	{
		case XR_E_ABSTRACT_BASE_CLASS:
			return pszErrorStrings[0];
		case XR_E_COLLECTION_DUPLICATE_NAME:
			return pszErrorStrings[1];
		case XR_E_COLLECTION_ELEMENT_ALREADY_ASSOCIATED:
			return pszErrorStrings[2];
		case XR_E_DUPLICATE_REGISTRATION:
			return pszErrorStrings[3];
		case XR_E_ELEMENT_NOT_CREATED:
			return pszErrorStrings[4];
		case XR_E_ELEMENT_NOT_FOUND:
			return pszErrorStrings[5];
		case XR_E_INVALID_OBJECT:
			return pszErrorStrings[6];
		case XR_E_INVALID_PROPERTY:
			return pszErrorStrings[7];
		case XR_E_INVALID_ROOT_FOR_CREATING_HOST:
			return pszErrorStrings[8];
		case XR_E_INVALID_STATE:
			return pszErrorStrings[9];
		case XR_E_INVALID_THREAD_ACCESS:
			return pszErrorStrings[10];
		case XR_E_NOT_INITIALIZED:
			return pszErrorStrings[11];
		case XR_E_PARSER_ATTRIBUTE_OUT_OF_RANGE:
			return pszErrorStrings[12];
		case XR_E_PARSER_ATTRIBUTE_READONLY:
			return pszErrorStrings[13];
		case XR_E_PARSER_FAILED_RESOURCE_FIND:
			return pszErrorStrings[14];
		case XR_E_PARSER_INVALID_ATTRIBUTE:
			return pszErrorStrings[15];
		case XR_E_PARSER_INVALID_ATTRIBUTE_VALUE:
			return pszErrorStrings[16];
		case XR_E_PARSER_INVALID_CONTENT:
			return pszErrorStrings[17];
		case XR_E_PARSER_INVALID_PROPERTY:
			return pszErrorStrings[18];
		case XR_E_PARSER_MISSING_DEFAULT_NAMESPACE:
			return pszErrorStrings[19];
		case XR_E_PARSER_MULTIPLE_PROPERTY_ELEMENT_VALUES:
			return pszErrorStrings[20];
		case XR_E_PARSER_RESOURCE_KEY_AND_NAME_SET:
			return pszErrorStrings[21];
		case XR_E_PARSER_TEXT_CONTENT_UNSUPPORTED:
			return pszErrorStrings[22];
		case XR_E_PARSER_UNKNOWN_ATTRIBUTE:
			return pszErrorStrings[23];
		case XR_E_PARSER_UNKNOWN_ELEMENT:
			return pszErrorStrings[24];
		case XR_E_PARSER_UNKNOWN_NAMESPACE:
			return pszErrorStrings[25];
		case XR_E_STORYBOARD_BEGIN_ANIMATION_COMPOSITION:
			return pszErrorStrings[26];
		case XR_E_STORYBOARD_BEGIN_INCOMPATIBLE_TYPE:
			return pszErrorStrings[27];
		case XR_E_STORYBOARD_BEGIN_INVALID_KEYTIME:
			return pszErrorStrings[28];
		case XR_E_STORYBOARD_BEGIN_INVALID_PROPERTY:
			return pszErrorStrings[29];
		case XR_E_STORYBOARD_BEGIN_INVALID_TARGET:
			return pszErrorStrings[30];
		case XR_E_STORYBOARD_BEGIN_NO_TARGET:
			return pszErrorStrings[31];
		case XR_E_STORYBOARD_MODIFY_ACTIVE_ANIMATION:
			return pszErrorStrings[32];
		case XR_E_STORYBOARD_MUST_BE_ROOT:
			return pszErrorStrings[33];
		case XR_E_STORYBOARD_SKIPTOFILL_NO_DURATION:
			return pszErrorStrings[34];
		default:
			_stprintf(pszUnknownMessage,TEXT("UNKNOWN_ERROR (0x%x)"), retcode);
			return pszUnknownMessage;
	}
}

// EventHandler class
class BtnEventHandler
{
public:
    HRESULT OnPlayClick(IXRDependencyObject* source,XRMouseButtonEventArgs* args)
    {
        MessageBox(NULL,TEXT("Click!"),TEXT("Silverlight for Embedded test"),MB_OK);
        return S_OK;
    }
	HRESULT OnPauseClick(IXRDependencyObject* source,XRMouseButtonEventArgs* args)
    {
        MessageBox(NULL,TEXT("Click!"),TEXT("Silverlight for Embedded test"),MB_OK);
        return S_OK;
    }
	HRESULT OnStopClick(IXRDependencyObject* source,XRMouseButtonEventArgs* args)
    {
        MessageBox(NULL,TEXT("Click!"),TEXT("Silverlight for Embedded test"),MB_OK);
        return S_OK;
    }
	HRESULT OnExitClick(IXRDependencyObject* source,XRMouseButtonEventArgs* args)
    {
        g_vhost->EndDialog(0);
        return S_OK;
    }
};

int WINAPI WinMain(HINSTANCE hInstance,
                   HINSTANCE hPrevInstance,
                   LPTSTR    lpCmdLine,
                   int       nCmdShow)
{
	HRESULT retcode;
	IXRApplicationPtr app;
	XRWindowCreateParams wp;
	XRXamlSource xamlsrc;
	IXRFrameworkElementPtr root;
	IXRButtonBasePtr btnPlay;
	IXRButtonBasePtr btnStop;
	IXRButtonBasePtr btnPause;
	IXRButtonBasePtr btnExit;
	BtnEventHandler	buttonHandler;
	UINT exitcode;

	if (!XamlRuntimeInitialize())
	{
		RETAILMSG(1,(L"[SILVERLIGHT EXAMPLE]:  XamlRuntimeInitialize failed. "
			L"Make sure your system includes Silverlight.\r\n"));
        return -1;
	}

    if (FAILED(retcode=GetXRApplicationInstance(&app)))
	{
		RETAILMSG(1,(L"[SILVERLIGHT EXAMPLE]: GetXRApplicationInstance "
			L"failed. Error = %s\r\n", GetSilverLightErrorString(retcode)));
		return -1;
	}

    ZeroMemory(&wp, sizeof(XRWindowCreateParams));
    wp.Style       = WS_OVERLAPPED;
    wp.pTitle      = L"Silverlight Player Example";
    wp.Left        = 0;
    wp.Top         = 0;

	// load our specified Xaml
    //
    ZeroMemory(&xamlsrc, sizeof(xamlsrc));
	/* I included the xaml file in the project and it is deployed along with 
	 * the program. By feeding another xaml that has the same buttons you can 
	 * easily change the way the program looks without touching the code 
	 */
    xamlsrc.SetFile(lpCmdLine);

    if (FAILED(retcode=app->CreateHostFromXaml(&xamlsrc, &wp, &g_vhost)))
	{
		RETAILMSG(1,(L"[SILVERLIGHT EXAMPLE]: CreateHostFromXaml "
			L"failed. Check the xaml file\r\n"));
		return -1;
	}

	/* Get the root element of the xaml graph. After all, it is xml format */
    if (FAILED(retcode=g_vhost->GetRootElement(&root)))
	{
		RETAILMSG(1,(L"[SILVERLIGHT EXAMPLE]: GetRootElement "
			L"failed. Error = %s\r\n", GetSilverLightErrorString(retcode)));
		return -1;
	}

	/* This is were the Designer and Developer have to be 
	 * aligned -> Object Names 
	 */
    if (FAILED(retcode=root->FindName(TEXT("PlayButton"), &btnPlay)))
	{
		RETAILMSG(1,(L"[SILVERLIGHT EXAMPLE]: FindName->PlayButton "
			L"failed. Error = %s\r\n", GetSilverLightErrorString(retcode)));
		return -1;
	}

	if (btnPlay != NULL)
	{
	/* In the future MS will release a Macro to do this event<->delegate bonding */
		btnPlay->AddClickEventHandler(
			CreateDelegate(&buttonHandler, &BtnEventHandler::OnPlayClick));
	}

	if (FAILED(retcode=root->FindName(TEXT("PauseButton"), &btnPause)))
	{
		RETAILMSG(1,(L"[SILVERLIGHT EXAMPLE]: FindName->PauseButton "
			L"failed. Error = %s\r\n", GetSilverLightErrorString(retcode)));
		return -1;
	}

	if (btnPause != NULL)
	{
		btnPause->AddClickEventHandler(
			CreateDelegate(&buttonHandler, &BtnEventHandler::OnPauseClick));
	}

	if (FAILED(retcode=root->FindName(TEXT("StopButton"), &btnStop)))
	{
		RETAILMSG(1,(L"[SILVERLIGHT EXAMPLE]: FindName->StopButton "
			L"failed. Error = %s\r\n", GetSilverLightErrorString(retcode)));
		return -1;
	}

	if (btnStop != NULL)
	{
		btnStop->AddClickEventHandler(
			CreateDelegate(&buttonHandler, &BtnEventHandler::OnStopClick));
	}

	if (FAILED(retcode=root->FindName(TEXT("ExitButton"), &btnExit)))
	{
		RETAILMSG(1,(L"[SILVERLIGHT EXAMPLE]: FindName->ExitButton "
			L"failed. Error = %s\r\n", GetSilverLightErrorString(retcode)));
		return -1;
	}

	if (btnExit != NULL)
	{
		btnExit->AddClickEventHandler(
			CreateDelegate(&buttonHandler, &BtnEventHandler::OnExitClick));
	}

	if (FAILED(retcode=g_vhost->StartDialog(&exitcode)))
	{
		RETAILMSG(1,(L"[SILVERLIGHT EXAMPLE]: StartDialog "
			L"failed. Error = %s\r\n", GetSilverLightErrorString(retcode)));
		return -1;
	}

	//Clean resources - after ExitBtn was pressed
	g_vhost->DestroyWindow();


	return 0;
}