/******************************************************************************
// (C) Copyright 2006 Marvell International Ltd.
// All Rights Reserved
// INTEL CONFIDENTIAL
// Copyright 2000 ~ 2006 Intel Corporation All Rights Reserved. 
// The source code contained or described herein and all documents related to 
// the source code (Material) are owned by Intel Corporation or its 
// suppliers or licensors. Title to the Material remains with Intel Corporation
// or its suppliers and licensors. The Material contains trade secrets and 
// proprietary and confidential information of Intel or its suppliers and 
// licensors. The Material is protected by worldwide copyright and trade secret 
// laws and treaty provisions. No part of the Material may be used, copied, 
// reproduced, modified, published, uploaded, posted, transmitted, distributed, 
// or disclosed in any way without Intels prior express written permission.
//
// No license under any patent, copyright, trade secret or other intellectual 
// property right is granted to or conferred upon you by disclosure or delivery 
// of the Materials, either expressly, by implication, inducement, estoppel or 
// otherwise. Any license under such intellectual property rights must be 
// express and approved by Intel in writing.
******************************************************************************/
#ifndef _MISC_H_
#define _MISC_H_

#include <stdlib.h>
#include <stdio.h>

#ifndef Symbian
#include <memory.h>
#endif

#include "codecDef.h"

#ifdef __cplusplus
extern "C" {
#endif

extern int miscgMemMalloc(void **ppDstBuf, int size, unsigned char align);
extern int miscgMemCalloc(void **ppDstBuf, int size, unsigned char align);
extern int miscgMemFree(void **ppSrcBuf);
extern int miscgStreamFlush(void *pStream, void *pStreamHandle, int nAvailBytes, int extMode);

extern int miscInitGeneralCallbackTable(MiscGeneralCallbackTable **ppDstCBTable);
extern int miscFreeGeneralCallbackTable(MiscGeneralCallbackTable **ppSrcCBTable);
extern int miscSeekFileCallBack(void *handler, int offset, int start);
extern int miscReadFileCallBack(void *pBuf, int unit, int number, void *handler);
extern int miscWriteFileCallBack(void *pBuf, int unit, int number, void *handler);

#ifdef __cplusplus
}
#endif

#endif

