/******************************************************************************
// INTEL CONFIDENTIAL
// Copyright 2000 ~ 2006 Intel Corporation All Rights Reserved. 
// The source code contained or described herein and all documents related to 
// the source code (Material) are owned by Intel Corporation or its 
// suppliers or licensors. Title to the Material remains with Intel Corporation
// or its suppliers and licensors. The Material contains trade secrets and 
// proprietary and confidential information of Intel or its suppliers and 
// licensors. The Material is protected by worldwide copyright and trade secret 
// laws and treaty provisions. No part of the Material may be used, copied, 
// reproduced, modified, published, uploaded, posted, transmitted, distributed, 
// or disclosed in any way without Intels prior express written permission.
//
// No license under any patent, copyright, trade secret or other intellectual 
// property right is granted to or conferred upon you by disclosure or delivery 
// of the Materials, either expressly, by implication, inducement, estoppel or 
// otherwise. Any license under such intellectual property rights must be 
// express and approved by Intel in writing.
******************************************************************************/
#include <stdio.h>
#include "ippdefs.h"

#ifndef _CALLBACK
#define _CALLBACK __STDCALL
#endif

void* _CALLBACK ippiMalloc(int size)
{
    return malloc(size);
}

void _CALLBACK ippiFree(void* pSrcBuf)
{
    free(pSrcBuf);
}

/* ////////////////////////////////////////////////////////////////////////// */

/* /////////////////////////////////////////////////////////////////////////////
//  Name:       ippMalloc
//  Purpose:    allocates aligned (32 bytes) arrays
//  Returns:    actual pointer, if no errors
//              NULL, if out of memory or if incorrect length
//  Parameter:
//    length  - sizeof in bytes
//
//  Notes:      You should release memory only by function ippFree()
*/

void* ippMalloc(int length)
{
    void *ptr = (void*)0;                                                                                                          \
    ptr = malloc(length + 32 + sizeof(void*));
    if (ptr) {                                                                         
        void **ap = (void**)( ((unsigned long)(ptr) + 32 
		+ sizeof(void*) - 1 ) & (~0x1F) );            
        ap[-1] = (void*)ptr;                                                           
        return (void *)ap;                                                            
    }else{
		return NULL;
	}
}

/* /////////////////////////////////////////////////////////////////////////////
//  Name:       ippFree
//  Purpose:    frees memory allocated by ipps*Malloc
//  Parameter:
//    ptr     - the pointer on memory, which allocated by ippsMalloc*
//
//  Notes: function correctly free memory, which allocated ippsMalloc*() only
*/
void ippFree(void* ptr) 
{
   if( ptr )free( ((void**)ptr)[-1] );
}

/* //////////////////////// End of file "ippimem.c" ///////////////////////// */
