/*************************************************************************/
/*  Copyright (c) 2005-2006  Marvell Corporation.                        */
/*  All rights reserved.                                                 */
/*************************************************************************/


#ifndef __DMO_IID_MTID_DEF_H_
#define __DMO_IID_MTID_DEF_H_


#include <mmreg.h>      // Use WAVE_FORMAT_MPEGLAYER3 definition in this header

//----------------------- WMA Decoder DMO --------------------------//
// IPP WMA DMO Decoder
// {25A69EC2-AB66-4523-847A-98DAB2F9A9EE}
DEFINE_GUID(CLSID_WMADMOD, \
0x25A69EC2, 0xab66, 0x4523, 0x84, 0x7a, 0x98, 0xda, 0xb2, 0xf9, 0xa9, 0xee);

// Wrapped Filter which contains this OMX AAC DMO Decoder
// {BF03B172-1DF1-4017-B47A-F0DBAFFA4C7A}
static const GUID CLSID_WMADMODWRAPPEDFILTER = \
{ 0xbf03b172, 0x1df1, 0x4017, { 0xb4, 0x7a, 0xf0, 0xdb, 0xaf, 0xfa, 0x4c, 0x7a } };

//----------------------- MP3 Decoder DMO --------------------------//
// IPP MP3 DMO Decoder
// {338AF319-4BD3-44f7-80A4-CA57C25F93E2}
DEFINE_GUID(CLSID_MP3DMOD, \
0x338af319, 0x4bd3, 0x44f7, 0x80, 0xa4, 0xca, 0x57, 0xc2, 0x5f, 0x93, 0xe2);

// MEDIASUBTYPE_MP3
// {00000055-0000-0010-8000-00AA00389B71}
static const GUID MEDIASUBTYPE_MP3 = \
{ WAVE_FORMAT_MPEGLAYER3, 0x0000, 0x0010, { 0x80, 0x00, 0x00, 0xaa, 0x00, 0x38, 0x9b, 0x71 } };

// Wrapped Filter which contains this IPP MP3 DMO Decoder
// {8E0AAC10-BC46-43da-8A22-8BFCCAA676B2}
static const GUID CLSID_MP3DMODWRAPPEDFILTER = \
{ 0x8e0aac10, 0xbc46, 0x43da, { 0x8a, 0x22, 0x8b, 0xfc, 0xca, 0xa6, 0x76, 0xb2 } };



//----------------------- AAC Decoder DMO --------------------------//
// IPP AAC DMO Decoder
// {1096F3B6-AB66-4523-847A-98DAB2F9A9EE}
DEFINE_GUID(CLSID_AACDMOD, \
0x1096f3b6, 0xab66, 0x4523, 0x84, 0x7a, 0x98, 0xda, 0xb2, 0xf9, 0xa9, 0xee);

// Be compatible with 3ivx
static const DWORD WAVE_FORMAT_AAC (0x000000FF);
static const DWORD WAVE_FORMAT_MARVELL_AACLTP (0x0000F004);

// MEDIASUBTYPE_AAC
// {000000FF-0000-0010-8000-00AA00389B71}
static const GUID MEDIASUBTYPE_AAC = \
{ WAVE_FORMAT_AAC, 0x0000, 0x0010, { 0x80, 0x00, 0x00, 0xaa, 0x00, 0x38, 0x9b, 0x71 } };

// Wrapped Filter which contains this OMX AAC DMO Decoder
// {BF03B171-1DF1-4017-B47A-F0DBAFFA4C7A}
static const GUID CLSID_AACDMODWRAPPEDFILTER = \
{ 0xbf03b171, 0x1df1, 0x4017, { 0xb4, 0x7a, 0xf0, 0xdb, 0xaf, 0xfa, 0x4c, 0x7a } };



//----------------------- H.263 Decoder DMO --------------------------//
// IPP H.263 DMO Decoder
// {E3853AD4-1DA9-4f3c-9CFD-7D14D533B395}
DEFINE_GUID(CLSID_H263DMOD, \
0xe3853ad4, 0x1da9, 0x4f3c, 0x9c, 0xfd, 0x7d, 0x14, 0xd5, 0x33, 0xb3, 0x95);

// MEDIASUBTYPE_H263
// {33363248-0000-0010-8000-00AA00389B71}
static const GUID MEDIASUBTYPE_H263 = \
{ MAKEFOURCC('H', '2', '6', '3'), 0x0000, 0x0010, { 0x80, 0x00, 0x00, 0xaa, 0x00, 0x38, 0x9b, 0x71 } };

// MEDIASUBTYPE_h263
// {33363268-0000-0010-8000-00AA00389B71}
static const GUID MEDIASUBTYPE_h263 = \
{ MAKEFOURCC('h', '2', '6', '3'), 0x0000, 0x0010, { 0x80, 0x00, 0x00, 0xaa, 0x00, 0x38, 0x9b, 0x71 } };

// MEDIASUBTYPE_S263
// {33363248-0000-0010-8000-00AA00389B71}
static const GUID MEDIASUBTYPE_S263 = \
{ MAKEFOURCC('S', '2', '6', '3'), 0x0000, 0x0010, { 0x80, 0x00, 0x00, 0xaa, 0x00, 0x38, 0x9b, 0x71 } };

// MEDIASUBTYPE_s263
// {33363268-0000-0010-8000-00AA00389B71}
static const GUID MEDIASUBTYPE_s263 = \
{ MAKEFOURCC('s', '2', '6', '3'), 0x0000, 0x0010, { 0x80, 0x00, 0x00, 0xaa, 0x00, 0x38, 0x9b, 0x71 } };

// Wrapped Filter which contains this OMX H.263 DMO Decoder
// {238D030D-BEBA-4036-B8AB-6AFCD1FBF0DF}
static const GUID CLSID_H263DMODWRAPPEDFILTER = \
{ 0x238d030d, 0xbeba, 0x4036, { 0xb8, 0xab, 0x6a, 0xfc, 0xd1, 0xfb, 0xf0, 0xdf } };


//----------------------- MPEG4 ASP Decoder DMO --------------------------//
// IPP MPEG4 ASP DMO Decoder
// {7D4FA19E-6656-44b8-B9B4-F1D78F424752}
DEFINE_GUID(CLSID_MPEG4ASPDMOD, \
0x7d4fa19e, 0x6656, 0x44b8, 0xb9, 0xb4, 0xf1, 0xd7, 0x8f, 0x42, 0x47, 0x52);

// MEDIASUBTYPE_MP4V
// {5634504D-0000-0010-8000-00AA00389B71}
static const GUID MEDIASUBTYPE_MP4V = \
{ MAKEFOURCC('M', 'P', '4', 'V'), 0x0000, 0x0010, { 0x80, 0x00, 0x00, 0xaa, 0x00, 0x38, 0x9b, 0x71 } };

// MEDIASUBTYPE_mp4v
// {7634706D-0000-0010-8000-00AA00389B71}
static const GUID MEDIASUBTYPE_mp4v = \
{ MAKEFOURCC('m', 'p', '4', 'v'), 0x0000, 0x0010, { 0x80, 0x00, 0x00, 0xaa, 0x00, 0x38, 0x9b, 0x71 } };

// Wrapped Filter which contains this MPEG4 ASP DMO Decoder
// {2BDE44B1-9F1A-415e-AAC3-55C3D79F1CE0}
static const GUID CLSID_MPEG4ASPDMODWRAPPEDFILTER = \
{ 0x2bde44b1, 0x9f1a, 0x415e, { 0xaa, 0xc3, 0x55, 0xc3, 0xd7, 0x9f, 0x1c, 0xe0 } };



//----------------------- H.263 Encoder DMO --------------------------//
// IPP H.263 Encoder DMO
// {B4FE68BB-2211-4caa-B44F-C01C6115DD00}
DEFINE_GUID(CLSID_H263DMOE, \
0xb4fe68bb, 0x2211, 0x4caa, 0xb4, 0x4f, 0xc0, 0x1c, 0x61, 0x15, 0xdd, 0x00);

// Wrapped Filter which contains this OMX H.263 Encoder DMO
// {12515436-32D3-49d3-8380-849476D52DB5}
static const GUID CLSID_H263DMOEWRAPPEDFILTER = \
{ 0x12515436, 0x32d3, 0x49d3, { 0x83, 0x80, 0x84, 0x94, 0x76, 0xd5, 0x2d, 0xb5 } };

// Parameters for H.263 Encoder DMO Interface
typedef struct _H263DMOE_PARAMMETERS {
    int     SrcSampRate;    // 1-5, default 1
                            // only 1 is enabled currently
    int     RCEnable;       // 0: disable, 1: enable
                            // default 1
    int     BitRate;        // if RCEnable set to 1, this parameter must > 0. default 64000
                            // if RCEnable set to 0, any value of this parameter will be ignored
    int     PBetweenI;      // >= -1, default 20
                            // -1 indicates just one I-frame in starting point, no more I-frame
    int     MEStrategy;     // 0: ME_PERFORMANCE_BIAS
                            // 1: ME_QUALITY_BIAS
                            // default 1
	int     Profile;        // 0 for profile 0, 3 for profile 3. default 0
} H263DMOE_PARAMMETERS, *P_H263DMOE_PARAMMETERS;

#ifdef __cplusplus
extern "C" {
#endif

    // H.263 Encoder DMO Unique Interface
    // {5B20A8F8-1910-40a8-8397-E9D80182CDB7}
    DEFINE_GUID(IID_H263DMOE, \
    0x5b20a8f8, 0x1910, 0x40a8, 0x83, 0x97, 0xe9, 0xd8, 0x1, 0x82, 0xcd, 0xb7);

    DECLARE_INTERFACE_(IH263Enc, IUnknown)
    {
        STDMETHOD(DMOGetParam) (THIS_ P_H263DMOE_PARAMMETERS pH263EParam) PURE;
        STDMETHOD(DMOSetParam) (THIS_ P_H263DMOE_PARAMMETERS pH263EParam) PURE;
        STDMETHOD(DMOResetParam) (THIS_) PURE;
    };

    struct __declspec(uuid("5B20A8F8-1910-40a8-8397-E9D80182CDB7")) IH263Enc;

#ifdef __cplusplus
}
#endif



//----------------------- H.264 Decoder DMO --------------------------//
// IPP H.264 DMO Decoder
// {E64BEE28-978F-4f33-98A9-28FD4018FEA6}
DEFINE_GUID(CLSID_H264DMOD, \
0xe64bee28, 0x978f, 0x4f33, 0x98, 0xa9, 0x28, 0xfd, 0x40, 0x18, 0xfe, 0xa6);

// MEDIASUBTYPE_H264
// {34363248-0000-0010-8000-00AA00389B71}
static const GUID MEDIASUBTYPE_H264 = \
{ MAKEFOURCC('H', '2', '6', '4'), 0x0000, 0x0010, { 0x80, 0x00, 0x00, 0xaa, 0x00, 0x38, 0x9b, 0x71 } };

// MEDIASUBTYPE_h264
// {34363268-0000-0010-8000-00AA00389B71}
static const GUID MEDIASUBTYPE_h264 = \
{ MAKEFOURCC('h', '2', '6', '4'), 0x0000, 0x0010, { 0x80, 0x00, 0x00, 0xaa, 0x00, 0x38, 0x9b, 0x71 } };

static const GUID MEDIASUBTYPE_AVC1 = \
{ MAKEFOURCC('A', 'V', 'C', '1'), 0x0000, 0x0010, { 0x80, 0x00, 0x00, 0xaa, 0x00, 0x38, 0x9b, 0x71 } };
static const GUID MEDIASUBTYPE_avc1 = \
{ MAKEFOURCC('a', 'v', 'c', '1'), 0x0000, 0x0010, { 0x80, 0x00, 0x00, 0xaa, 0x00, 0x38, 0x9b, 0x71 } };

// MEDIASUBTYPE_X264
// {343632-0000-0010-8000-00AA00389B71}
static const GUID MEDIASUBTYPE_X264 = \
{ MAKEFOURCC('X', '2', '6', '4'), 0x0000, 0x0010, { 0x80, 0x00, 0x00, 0xaa, 0x00, 0x38, 0x9b, 0x71 } };

// MEDIASUBTYPE_x264
// {343632-0000-0010-8000-00AA00389B71}
static const GUID MEDIASUBTYPE_x264 = \
{ MAKEFOURCC('x', '2', '6', '4'), 0x0000, 0x0010, { 0x80, 0x00, 0x00, 0xaa, 0x00, 0x38, 0x9b, 0x71 } };

// Wrapped Filter which contains this OMX H.264 DMO Decoder
// {572A6F3E-F3BD-47fd-91F9-FF111D416B2C}
static const GUID CLSID_H264DMODWRAPPEDFILTER = \
{ 0x572a6f3e, 0xf3bd, 0x47fd, { 0x91, 0xf9, 0xff, 0x11, 0x1d, 0x41, 0x6b, 0x2c } };

#ifdef __cplusplus
extern "C" {
#endif

    // H.264 Decoder DMO Unique Interface
    // {147A8037-3AC0-4467-A4B0-C0B7D85A7F4A}
    DEFINE_GUID(IID_H264DMOD, \
        0x147a8037, 0x3ac0, 0x4467, 0xa4, 0xb0, 0xc0, 0xb7, 0xd8, 0x5a, 0x7f, 0x4a);

    DECLARE_INTERFACE_(IH264Dec, IUnknown)
    {
    };

    struct __declspec(uuid("147A8037-3AC0-4467-A4B0-C0B7D85A7F4A")) IH264Dec;

#ifdef __cplusplus
}
#endif



//----------------------- H.264 Encoder DMO --------------------------//
// IPP H.264 Encoder DMO
// {59D35DEB-118D-458d-AFFD-B1BA5502CFAB}
DEFINE_GUID(CLSID_H264DMOE, \
0x59d35deb, 0x118d, 0x458d, 0xaf, 0xfd, 0xb1, 0xba, 0x55, 0x2, 0xcf, 0xab);

// Wrapped Filter which contains this OMX H.264 Encoder DMO
// {8B6B3F0A-EAC4-4a98-A5C3-A9CC5AFC7441}
static const GUID CLSID_H264DMOEWRAPPEDFILTER = \
{ 0x8b6b3f0a, 0xeac4, 0x4a98, { 0xa5, 0xc3, 0xa9, 0xcc, 0x5a, 0xfc, 0x74, 0x41 } };

// Parameters for H.264 Encoder DMO Interface
typedef struct _H264DMOE_PARAMMETERS {
    int     RCEnable;       // 0: disable, 1: enable
                            // default 1
    int     BitRate;        // if RCEnable set to 1, this parameter must > 0. default 64000
                            // if RCEnable set to 0, any value of this parameter will be ignored
    int     initQP;         // Quantization Parameter for the 1st frame (10 - 51, inclusive)
                            // If RC is not enabled, this value will be used to quantize all 
                            // frames, otherwise, this value will be overloaded by QP value 
                            // computed by rate control.
                            // For baseline profile, QP<10 will cause dynamic range overflow 
                            // of certain DC coefficients, so QP needs to be greater than or 
                            // equal to 10.
                            // default 28, not enabled currently
    int     highQuality;    // whether encode using high quality configuration
                            // 0: low quality, 1: high quality
                            // default 1, not enabled currently
    int     delayLimit;     // Target end-to-end delay limitation (Unit: ms)
                            // If RC is enabled, this value should be greater than 0.
                            // For realtime application, such as videophone or video 
                            // conference, the typical delay constraint is 500ms.
                            // For non-realtime application, there is no constraint on end-end 
                            // delay, this value can be any greater than 0, but any value 
                            // greater than 2000 will be reset to 2000 internally.
                            // default 500
} H264DMOE_PARAMMETERS, *P_H264DMOE_PARAMMETERS;

#ifdef __cplusplus
extern "C" {
#endif

    // H.264 Encoder DMO Unique Interface
    // {433B9467-F570-405f-8B24-42B9AA6DF635}
    DEFINE_GUID(IID_H264DMOE, \
    0x433b9467, 0xf570, 0x405f, 0x8b, 0x24, 0x42, 0xb9, 0xaa, 0x6d, 0xf6, 0x35);

    DECLARE_INTERFACE_(IH264Enc, IUnknown)
    {
        STDMETHOD(DMOGetParam) (THIS_ P_H264DMOE_PARAMMETERS pH264EParam) PURE;
        STDMETHOD(DMOSetParam) (THIS_ P_H264DMOE_PARAMMETERS pH264EParam) PURE;
        STDMETHOD(DMOResetParam) (THIS_) PURE;
		STDMETHOD(DMOGetSrcPtr) (THIS_ DWORD * pSrcAddress) PURE;
    };

    struct __declspec(uuid("433B9467-F570-405f-8B24-42B9AA6DF635")) IH264Enc;

#ifdef __cplusplus
}
#endif



//----------------------- MPEG-4 Encoder DMO --------------------------//
// IPP MPEG-4 DMO Encoder
// {C981BE1E-4C7A-4eaf-8E9B-4C467600E6CA}
DEFINE_GUID(CLSID_MPEG4DMOE, \
0xc981be1e, 0x4c7a, 0x4eaf, 0x8e, 0x9b, 0x4c, 0x46, 0x76, 0x0, 0xe6, 0xca);

// Wrapped Filter which contains this MPEG-4 Encoder DMO
// {F758F2CB-B565-4b26-829F-16A4051DCC73}
static const GUID CLSID_MPEG4DMOEWRAPPEDFILTER= \
{ 0xf758f2cb, 0xb565, 0x4b26, { 0x82, 0x9f, 0x16, 0xa4, 0x5, 0x1d, 0xcc, 0x73 } };

// Parameters for MPEG-4 DMO Encoder Interface
typedef struct _MPEG4DMOE_PARAMMETERS {
    int     SrcSampRate;    // 1-5, default 1
                            // only 1 is enabled currently
    int     RCEnable;       // 0: disable, 1: enable
                            // default 1
    int     BitRate;        // if RCEnable set to 1, this parameter must > 0. default 64000
                            // if RCEnable set to 0, any value of this parameter will be ignored
    int     PBetweenI;      // >= -1, default 20
                            // -1 indicates just one I-frame in starting point, no more I-frame
    int     MEStrategy;     // 0: ME_PERFORMANCE_BIAS
                            // 1: ME_QUALITY_BIAS
                            // default 1
} MPEG4DMOE_PARAMMETERS, *P_MPEG4DMOE_PARAMMETERS;

#ifdef __cplusplus
extern "C" {
#endif

    // MPEG-4 DMO Encoder Unique Interface
	// {8541D2B4-1C88-4b70-9DC3-EE2CB7086DE8}
	DEFINE_GUID(IID_MPEG4DMOE, \
	0x8541d2b4, 0x1c88, 0x4b70, 0x9d, 0xc3, 0xee, 0x2c, 0xb7, 0x8, 0x6d, 0xe8);

    DECLARE_INTERFACE_(IMPEG4Enc, IUnknown)
    {
        STDMETHOD(DMOGetParam) (THIS_ P_MPEG4DMOE_PARAMMETERS pMPEG4EncParam) PURE;
        STDMETHOD(DMOSetParam) (THIS_ P_MPEG4DMOE_PARAMMETERS pMPEG4EncParam) PURE;
        STDMETHOD(DMOResetParam) (THIS_) PURE;
    };

    struct __declspec(uuid("8541D2B4-1C88-4b70-9DC3-EE2CB7086DE8")) IMPEG4Enc;

#ifdef __cplusplus
}
#endif


//----------------------- MPEG-2 Decoder DMO -----------------------//
// {29A436D0-B99B-441e-9DE1-9D53828768D2}
DEFINE_GUID(CLSID_MPEG2DMOD, \
0x29a436d0, 0xb99b, 0x441e, 0x9d, 0xe1, 0x9d, 0x53, 0x82, 0x87, 0x68, 0xd2);

// {D0C1FE3D-CB43-4f0e-8BFE-66A5781EA32C}
static const GUID CLSID_MPEG2DMODWRAPPEDFILTER = \
{ 0xd0c1fe3d, 0xcb43, 0x4f0e, { 0x8b, 0xfe, 0x66, 0xa5, 0x78, 0x1e, 0xa3, 0x2c } };





//----------------------- AMR Decoder DMO --------------------------//
// {F840FFFF-5FC3-423c-BD18-C065E07020CE}
DEFINE_GUID(CLSID_GSMAMRDECDMO, \
0xf840ffff, 0x5fc3, 0x423c, 0xbd, 0x18, 0xc0, 0x65, 0xe0, 0x70, 0x20, 0xce);

// Be compatible with mp4 splitter
static const DWORD WAVE_FORMAT_Marvell_GSMAMR (0xF001);

// FF01-0000-0010-8000-00aa00389b71
static const GUID MEDIASUBTYPE_GSMAMR = \
{ WAVE_FORMAT_Marvell_GSMAMR, 0x0000, 0x0010, { 0x80, 0x00, 0x00, 0xaa, 0x00, 0x38, 0x9b, 0x71 } };

// {ED8549FC-5FF4-4a69-98AE-4324E248B926}
static const GUID CLSID_GSMAMRDECWRAPPEDFILTER = \
{ 0xed8549fc, 0x5ff4, 0x4a69, { 0x98, 0xae, 0x43, 0x24, 0xe2, 0x48, 0xb9, 0x26 } };


//----------------------- AMR Encoder DMO --------------------------//
// {1C87751E-EEE3-42f0-A4B5-CD22F84A1D29}
DEFINE_GUID(CLSID_GSMAMRENCDMO, \
0x1c87751e, 0xeee3, 0x42f0, 0xa4, 0xb5, 0xcd, 0x22, 0xf8, 0x4a, 0x1d, 0x29);

// {E3F4655D-0E6A-427f-8023-B4E5DCA42FAF}
static const GUID CLSID_GSMAMRENCWRAPPEDFILTER = \
{ 0xe3f4655d, 0xe6a, 0x427f, { 0x80, 0x23, 0xb4, 0xe5, 0xdc, 0xa4, 0x2f, 0xaf } };

typedef struct _S_GSMAMRENCDMO_INTERFACE_ {
	int		eAMRBandMode;   /* from 0 to 7
						   	0: IPP_SPCHBR_4750,
							1: IPP_SPCHBR_5150,
							2: IPP_SPCHBR_5900,
							3: IPP_SPCHBR_6700,
							4: IPP_SPCHBR_7400,
							5: IPP_SPCHBR_7950,
							6: IPP_SPCHBR_10200,
							7: IPP_SPCHBR_12200 */
						    // default is 0
	int		eAMRDTXMode;    // 0 or 1, default is 1
} S_GSMAMRENCDMO_INTERFACE, * PS_GSMAMRENCDMO_INTERFACE;

#ifdef __cplusplus
extern "C" {
#endif

	// {D5F75C12-27F0-4842-9FC3-34E52DB2F80E}
	DEFINE_GUID(IID_GSMAMRENC, \
	0xd5f75c12, 0x27f0, 0x4842, 0x9f, 0xc3, 0x34, 0xe5, 0x2d, 0xb2, 0xf8, 0xe);

	DECLARE_INTERFACE_(IGSMAMREnc, IUnknown)
	{
		STDMETHOD(DMOSetParam) (THIS_ PS_GSMAMRENCDMO_INTERFACE pEncParam) PURE;
		STDMETHOD(DMOGetParam) (THIS_ PS_GSMAMRENCDMO_INTERFACE pEncParam) PURE;				
		STDMETHOD(DMOResetParam) (THIS_) PURE;				
	};

	struct __declspec(uuid("D5F75C12-27F0-4842-9FC3-34E52DB2F80E")) IGSMAMREnc;

#ifdef __cplusplus
}
#endif


//----------------------- AMRWB Decoder DMO --------------------------//
// {8B2F0404-8BDE-496e-8B93-9D86C9D83277}
DEFINE_GUID(CLSID_AMRWBDECDMO, \
0x8b2f0404, 0x8bde, 0x496e, 0x8b, 0x93, 0x9d, 0x86, 0xc9, 0xd8, 0x32, 0x77);

// Be compatible with mp4 splitter
static const DWORD WAVE_FORMAT_Marvell_AMRWB (0xF002);

// FF02-0000-0010-8000-00aa00389b71
static const GUID MEDIASUBTYPE_AMRWB = \
{ WAVE_FORMAT_Marvell_AMRWB, 0x0000, 0x0010, { 0x80, 0x00, 0x00, 0xaa, 0x00, 0x38, 0x9b, 0x71 } };

// {30580CC0-9504-4868-B34E-EF88CA59B451}
static const GUID CLSID_AMRWBDECWRAPPEDFILTER = \
{ 0x30580cc0, 0x9504, 0x4868, { 0xb3, 0x4e, 0xef, 0x88, 0xca, 0x59, 0xb4, 0x51 } };


//----------------------- AMRWB Encoder DMO --------------------------//
// {3897F497-D6B7-4b10-8752-BAE6B76B7162}
DEFINE_GUID(CLSID_AMRWBENCDMO, \
0x3897f497, 0xd6b7, 0x4b10, 0x87, 0x52, 0xba, 0xe6, 0xb7, 0x6b, 0x71, 0x62);

// {2266A776-0B0D-460c-BE50-3E2A92620BB1}
static const GUID CLSID_AMRWBENCWRAPPEDFILTER = \
{ 0x2266a776, 0xb0d, 0x460c, { 0xbe, 0x50, 0x3e, 0x2a, 0x92, 0x62, 0xb, 0xb1 } };

typedef struct _S_AMRWBENCDMO_INTERFACE_ {
	int		eAMRBandMode;   /* from 11 to 19
							11: IPP_SPCHBR_6600,
							12: IPP_SPCHBR_8850,
							13: IPP_SPCHBR_12650,
							14: IPP_SPCHBR_14250,
							15: IPP_SPCHBR_15850,
							16: IPP_SPCHBR_18250,
							17: IPP_SPCHBR_19850,
							18: IPP_SPCHBR_23050,
							19: IPP_SPCHBR_23850 */
							// default is 11
	int		eAMRDTXMode;	// 0 or 1, default is 1
} S_AMRWBENCDMO_INTERFACE, * PS_AMRWBENCDMO_INTERFACE;

#ifdef __cplusplus
extern "C" {
#endif

	// {67EE00E2-B955-4d4f-B4C7-845EE22D4979}
	DEFINE_GUID(IID_AMRWBENC, \
	0x67ee00e2, 0xb955, 0x4d4f, 0xb4, 0xc7, 0x84, 0x5e, 0xe2, 0x2d, 0x49, 0x79);

	DECLARE_INTERFACE_(IAMRWBEnc, IUnknown)
	{
		STDMETHOD(DMOSetParam) (THIS_ PS_AMRWBENCDMO_INTERFACE pEncParam) PURE;
		STDMETHOD(DMOGetParam) (THIS_ PS_AMRWBENCDMO_INTERFACE pEncParam) PURE;				
		STDMETHOD(DMOResetParam) (THIS_ ) PURE;				
	};

	struct __declspec(uuid("67EE00E2-B955-4d4f-B4C7-845EE22D4979")) IAMRWBEnc;

#ifdef __cplusplus
}
#endif


//----------------------- QCELP Decoder DMO --------------------------//
// BC5D6109-98F4-44d2-B937-B191845E1236
DEFINE_GUID(CLSID_QCELPDECDMO, \
0xbc5d6109, 0x98f4, 0x44d2, 0xb9, 0x37, 0xb1, 0x91, 0x84, 0x5e, 0x12, 0x36);

// Be compatible with mp4 splitter
static const DWORD WAVE_FORMAT_Marvell_QCELP (0xF003);

// ff03-0000-0010-8000-00aa00389b71
static const GUID MEDIASUBTYPE_QCELP = \
{ WAVE_FORMAT_Marvell_QCELP, 0x0000, 0x0010, { 0x80, 0x00, 0x00, 0xaa, 0x00, 0x38, 0x9b, 0x71 } };

// {F9C1B530-FE51-4d70-84FE-387C119791B3}
static const GUID CLSID_QCELPDECWRAPPEDFILTER = \
{ 0xf9c1b530, 0xfe51, 0x4d70, { 0x84, 0xfe, 0x38, 0x7c, 0x11, 0x97, 0x91, 0xb3 } };


//----------------------- QCELP Encoder DMO --------------------------//
// 5DB29163-AC23-4a2b-B53E-9A2E4DEFDE5D
DEFINE_GUID(CLSID_QCELPENCDMO, \
0x5db29163, 0xac23, 0x4a2b, 0xb5, 0x3e, 0x9a, 0x2e, 0x4d, 0xef, 0xde, 0x5d);

// {F9EB544F-CC56-47d3-A382-82E6B6CFA40D}
static const GUID CLSID_QCELPENCWRAPPEDFILTER = \
{ 0xf9eb544f, 0xcc56, 0x47d3, { 0xa3, 0x82, 0x82, 0xe6, 0xb6, 0xcf, 0xa4, 0xd } };

typedef struct _S_QCELPENCDMO_INTERFACE_ {
	int     nRateReduceMode;    // from 0 to 4, default is 0
} S_QCELPENCDMO_INTERFACE, * PS_QCELPENCDMO_INTERFACE;

#ifdef __cplusplus
extern "C" {
#endif

	// {3AA07842-6963-4572-A565-B804F0AAA26D}
	DEFINE_GUID(IID_QCELPENC, \
	0x3aa07842, 0x6963, 0x4572, 0xa5, 0x65, 0xb8, 0x4, 0xf0, 0xaa, 0xa2, 0x6d);

	DECLARE_INTERFACE_(IQCELPEnc, IUnknown)
	{
		STDMETHOD(DMOSetParam) (THIS_ PS_QCELPENCDMO_INTERFACE pEncParam) PURE;
		STDMETHOD(DMOGetParam) (THIS_ PS_QCELPENCDMO_INTERFACE pEncParam) PURE;				
		STDMETHOD(DMOResetParam) (THIS_) PURE;				
	};

	struct __declspec(uuid("3AA07842-6963-4572-A565-B804F0AAA26D")) IQCELPEnc;

#ifdef __cplusplus
}
#endif



#endif //__DMO_IID_MTID_DEF_H_


// EOF