/*****************************************************************************/
/*  Copyright (c) 2005-2006  Marvell Corporation.                            */
/*  All rights reserved.                                                     */
/*****************************************************************************/


#ifndef __FILTER_GUID_MT_IID_DEF_H_
#define __FILTER_GUID_MT_IID_DEF_H_

#include <mmreg.h>

#ifdef __cplusplus
extern "C" {
#endif


/**
 * CLSIDs for the filters
 */

// AAC Parser Filter
// {AE60F30D-2EC4-4635-A7D1-5694FDEFF54F}
DEFINE_GUID(CLSID_AACParser, \
0xae60f30d, 0x2ec4, 0x4635, 0xa7, 0xd1, 0x56, 0x94, 0xfd, 0xef, 0xf5, 0x4f);

// 3GP Splitter Filter
// {DDB9A920-5E09-4b82-B699-E76C19A3A1A0}
DEFINE_GUID(CLSID_3GPSplitter, \
0xddb9a920, 0x5e09, 0x4b82, 0xb6, 0x99, 0xe7, 0x6c, 0x19, 0xa3, 0xa1, 0xa0);

// 3GP Muxer Filter
// {AC96D9C4-1097-4bee-B466-7C0DB4E62528}
DEFINE_GUID(CLSID_3GPMuxer, \
0xac96d9c4, 0x1097, 0x4bee, 0xb4, 0x66, 0x7c, 0x0d, 0xb4, 0xe6, 0x25, 0x28);

// H.264 Decoder Filter
// {F4A3FD10-9F76-48e0-A8F5-C3EAB1DD7171}
DEFINE_GUID(CLSID_H264Dec, \
0xf4a3fd10, 0x9f76, 0x48e0, 0xa8, 0xf5, 0xc3, 0xea, 0xb1, 0xdd, 0x71, 0x71);

// MPEG-2 PS Demuxer Filter
// {787C1F4B-DBAE-4389-B8C2-F2DF6130FDBF}
DEFINE_GUID(CLSID_MPEG2Demuxer, \
0x787c1f4b, 0xdbae, 0x4389, 0xb8, 0xc2, 0xf2, 0xdf, 0x61, 0x30, 0xfd, 0xbf);

// MP3 Parser Filter
// {15DDA5C1-6F72-4b31-B792-0064AC5A9507}
DEFINE_GUID(CLSID_MP3Parser, \
0x15dda5c1, 0x6f72, 0x4b31, 0xb7, 0x92, 0x00, 0x64, 0xac, 0x5a, 0x95, 0x07);

// MPEG-2 Decoder Filter
// {B3F77255-D6A0-4e81-86F6-9A886B0F84B4}
DEFINE_GUID(CLSID_MPEG2Dec, \
0xb3f77255, 0xd6a0, 0x4e81, 0x86, 0xf6, 0x9a, 0x88, 0x6b, 0xf, 0x84, 0xb4);

// MPEG-4 Decoder Filter
// {56297B24-17EA-45ed-BBBD-5DA373FF491F}
DEFINE_GUID(CLSID_MPEG4Dec, \
0x56297b24, 0x17ea, 0x45ed, 0xbb, 0xbd, 0x5d, 0xa3, 0x73, 0xff, 0x49, 0x1f);

// AAC Decoder Filter
// {525EED75-DC65-4ab9-BA3A-50C20745E4F6}
DEFINE_GUID(CLSID_AACDec, \
0x525eed75, 0xdc65, 0x4ab9, 0xba, 0x3a, 0x50, 0xc2, 0x7, 0x45, 0xe4, 0xf6);

// H.263 Decoder Filter
// {18D210C9-4706-4474-8E9B-CD7B1F3CD02B}
DEFINE_GUID(CLSID_H263Dec, \
0x18d210c9, 0x4706, 0x4474, 0x8e, 0x9b, 0xcd, 0x7b, 0x1f, 0x3c, 0xd0, 0x2b);


/**
 * MEDIASUBTYPEs used by the filters
 */

// not registered MARVELL wave formats
#define WAVE_FORMAT_MARVELL_AMRNB               0xF001
#define WAVE_FORMAT_MARVELL_AMRWB               0xF002
#define WAVE_FORMAT_MARVELL_QCELP               0xF003
#define WAVE_FORMAT_MARVELL_AACLTP              0xF004

// used by ffdshow
#define WAVE_FORMAT_AAC                         0x00FF

// Container MEDIASUBTYPEs
static const GUID MEDIASUBTYPE_3GP = \
{ MAKEFOURCC('3', 'G', 'P', ' '),   0x0000, 0x0010, { 0x80, 0x00, 0x00, 0xaa, 0x00, 0x38, 0x9b, 0x71 } };

static const GUID MEDIASUBTYPE_MP4 = \
{ MAKEFOURCC('M', 'P', '4', ' '),   0x0000, 0x0010, { 0x80, 0x00, 0x00, 0xaa, 0x00, 0x38, 0x9b, 0x71 } };

// Speech MEDIASUBTYPEs
static const GUID MEDIASUBTYPE_AMRNB = \
{ WAVE_FORMAT_MARVELL_AMRNB,        0x0000, 0x0010, { 0x80, 0x00, 0x00, 0xaa, 0x00, 0x38, 0x9b, 0x71 } };

static const GUID MEDIASUBTYPE_AMRWB = \
{ WAVE_FORMAT_MARVELL_AMRWB,        0x0000, 0x0010, { 0x80, 0x00, 0x00, 0xaa, 0x00, 0x38, 0x9b, 0x71 } };

static const GUID MEDIASUBTYPE_QCELP = \
{ WAVE_FORMAT_MARVELL_QCELP,        0x0000, 0x0010, { 0x80, 0x00, 0x00, 0xaa, 0x00, 0x38, 0x9b, 0x71 } };

// Audio MEDIASUBTYPEs
static const GUID MEDIASUBTYPE_AAC = \
{ WAVE_FORMAT_AAC,                  0x0000, 0x0010, { 0x80, 0x00, 0x00, 0xaa, 0x00, 0x38, 0x9b, 0x71 } };

static const GUID MEDIASUBTYPE_MP3 = \
{ WAVE_FORMAT_MPEGLAYER3,           0x0000, 0x0010, { 0x80, 0x00, 0x00, 0xaa, 0x00, 0x38, 0x9b, 0x71 } };

// Video MEDIASUBTYPEs
static const GUID MEDIASUBTYPE_H263 = \
{ MAKEFOURCC('H', '2', '6', '3'),   0x0000, 0x0010, { 0x80, 0x00, 0x00, 0xaa, 0x00, 0x38, 0x9b, 0x71 } };

static const GUID MEDIASUBTYPE_h263 = \
{ MAKEFOURCC('h', '2', '6', '3'),   0x0000, 0x0010, { 0x80, 0x00, 0x00, 0xaa, 0x00, 0x38, 0x9b, 0x71 } };

static const GUID MEDIASUBTYPE_S263 = \
{ MAKEFOURCC('S', '2', '6', '3'),   0x0000, 0x0010, { 0x80, 0x00, 0x00, 0xaa, 0x00, 0x38, 0x9b, 0x71 } };

static const GUID MEDIASUBTYPE_s263 = \
{ MAKEFOURCC('s', '2', '6', '3'),   0x0000, 0x0010, { 0x80, 0x00, 0x00, 0xaa, 0x00, 0x38, 0x9b, 0x71 } };

static const GUID MEDIASUBTYPE_H264 = \
{ MAKEFOURCC('H', '2', '6', '4'),   0x0000, 0x0010, { 0x80, 0x00, 0x00, 0xaa, 0x00, 0x38, 0x9b, 0x71 } };

static const GUID MEDIASUBTYPE_h264 = \
{ MAKEFOURCC('h', '2', '6', '4'),   0x0000, 0x0010, { 0x80, 0x00, 0x00, 0xaa, 0x00, 0x38, 0x9b, 0x71 } };

static const GUID MEDIASUBTYPE_AVC1 = \
{ MAKEFOURCC('A', 'V', 'C', '1'),   0x0000, 0x0010, { 0x80, 0x00, 0x00, 0xaa, 0x00, 0x38, 0x9b, 0x71 } };

static const GUID MEDIASUBTYPE_avc1 = \
{ MAKEFOURCC('a', 'v', 'c', '1'),   0x0000, 0x0010, { 0x80, 0x00, 0x00, 0xaa, 0x00, 0x38, 0x9b, 0x71 } };

static const GUID MEDIASUBTYPE_MP4V = \
{ MAKEFOURCC('M', 'P', '4', 'V'),   0x0000, 0x0010, { 0x80, 0x00, 0x00, 0xaa, 0x00, 0x38, 0x9b, 0x71 } };

static const GUID MEDIASUBTYPE_mp4v = \
{ MAKEFOURCC('m', 'p', '4', 'v'),   0x0000, 0x0010, { 0x80, 0x00, 0x00, 0xaa, 0x00, 0x38, 0x9b, 0x71 } };


/**
 * Interface IDs of the filters
 */

//


#ifdef __cplusplus
}
#endif

#endif //__FILTER_GUID_MT_IID_DEF_H_


// EOF