/******************************************************************************
// (C) Copyright 2006 Marvell International Ltd.
// All Rights Reserved
// INTEL CONFIDENTIAL
// Copyright 2004 ~ 2006 Intel Corporation All Rights Reserved. 
// The source code contained or described herein and all documents related to 
// the source code (Material) are owned by Intel Corporation or its 
// suppliers or licensors. Title to the Material remains with Intel Corporation
// or its suppliers and licensors. The Material contains trade secrets and 
// proprietary and confidential information of Intel or its suppliers and 
// licensors. The Material is protected by worldwide copyright and trade secret 
// laws and treaty provisions. No part of the Material may be used, copied, 
// reproduced, modified, published, uploaded, posted, transmitted, distributed, 
// or disclosed in any way without Intels prior express written permission.
//
// No license under any patent, copyright, trade secret or other intellectual 
// property right is granted to or conferred upon you by disclosure or delivery 
// of the Materials, either expressly, by implication, inducement, estoppel or 
// otherwise. Any license under such intellectual property rights must be 
// express and approved by Intel in writing.
******************************************************************************/

#ifndef _EGLTYPES_H_
#define _EGLTYPES_H_

#if defined( _WIN32_WCE ) || defined( _WIN32 ) // WinCE
    #include "windows.h"
#else
    #ifndef APIENTRY
        #define APIENTRY
    #endif
    #ifndef GLAPI
        #define GLAPI extern
    #endif
#endif

typedef int int32_t;
/*
** Types and resources
*/
typedef int EGLBoolean;
typedef int32_t EGLint;
typedef void *EGLDisplay;
typedef void *EGLConfig;
typedef void *EGLSurface;
typedef void *EGLContext;



#if !(defined( _WIN32_WCE ) || defined( _WIN32 ) )
/*
    non-windows platform, need nwslayer.h
*/
#include "nwslayer.h"

#else
/*
    windows platform, don't need nwslayer.h
*/
typedef void*           NativeDisplayType;
typedef void*           NativeWindowType;   /* HWND on win32        */
typedef void*           NativePixmapType;   /* HBITMAP on win32     */

#endif


/*
** EGL and native handle values
*/
#define EGL_DEFAULT_DISPLAY ((NativeDisplayType)1)
#define EGL_NO_CONTEXT ((EGLContext)0)
#define EGL_NO_DISPLAY ((EGLDisplay)0)
#define EGL_NO_SURFACE ((EGLSurface)0)



#if !defined(__PIXMAP_DATA_STRUCTURE__)
#define __PIXMAP_DATA_STRUCTURE__
//Surface Format Types
typedef enum tagNWSSurfaceFormat           
{
        NWSFMT_Unknown=0, 
        NWSFMT_R5G6B5,            //RGB pairs: 565 
        NWSFMT_R5G5B5A1,        //RGBA pairs: 5551
        NWSFMT_R4G4B4A4,        //RGBA pairs: 4444 
        NWSFMT_R8G8B8,             //RGB pairs: 888
        NWSFMT_R8G8B8A8,         //RGBA pairs: 8888
        NWSFMT_L8, 
        NWSFMT_L8A8, 
        NWSFMT_A8, 
        NWSFMT_D16, 
        NWSFMT_D32
}NWSSurfaceFormat;

typedef struct tagNWSPixmap
{
		int		        iWidth;							 //Pixmap colorbuffer width
		int		        iHeight;						 //Pixmap colorbuffer width
		int				iStride;						 //Pixmap stride
		NWSSurfaceFormat    eFormat;						 //Pixmap colorbuffer format
		void*				pBits;							 //Pixmap colorbuffer pointer
}NWSPixmap;

#endif // __PIXMAP_DATA_STRUCTURE__

/* Extensions */
/*
#define GL_OES_query_matrix 1
GLAPI GLbitfield APIENTRY glQueryMatrixxOES (GLfixed *mantissa, GLint *exponent);
*/
#endif // _EGLTYPES_H_
