// SetWiFiPowerMode.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include <windows.h>
#include <commctrl.h>
#include "winioctl.h"
#include "ntddndis.h"
typedef ULONG NDIS_OID, *PNDIS_OID;
#include "nuiouser.h"


#define OID_802_11_POWER_MODE                   0x0D010216

int _tmain(int argc, _TCHAR* argv[])
{
	NDISUIO_SET_OID	NdisOIDData;
	NDISUIO_QUERY_OID NdisOIDQuery;
	TCHAR	szDeviceName[] = L"WLAN1";
	DWORD	dwWritten = 0;

	NdisOIDData.ptcDeviceName = szDeviceName;
	NdisOIDData.Oid = OID_802_11_POWER_MODE;
	/* The following 2 are the values the driver supports: */
	/* Ndis802_11PowerModeCAM  - Full power on always
	/* Ndis802_11PowerModeMAX_PSP - Full power save. reduces WiFi performance
	/************************************************************************/
	NdisOIDData.Data[0] = Ndis802_11PowerModeMAX_PSP;
	NdisOIDData.Data[1] = 0;
	NdisOIDData.Data[2] = 0;
	NdisOIDData.Data[3] = 0;
	DWORD  size = sizeof( NDISUIO_QUERY_OID ) + 2000; 
	PNDISUIO_QUERY_OID queryOID = (PNDISUIO_QUERY_OID)LocalAlloc( LPTR, size ); 
	

	HANDLE	hNdisDevice = CreateFile(NDISUIO_DEVICE_NAME,GENERIC_READ | GENERIC_WRITE,
				FILE_SHARE_READ | FILE_SHARE_WRITE,
				NULL, OPEN_EXISTING, 0, NULL);

	if (hNdisDevice != INVALID_HANDLE_VALUE)
	{
		BOOL	bResult = DeviceIoControl(hNdisDevice,
								 IOCTL_NDISUIO_SET_OID_VALUE,
								 &NdisOIDData,
								 sizeof(NdisOIDData),
								 &NdisOIDData,
								 sizeof(NdisOIDData),
								 &dwWritten,
								 NULL);
		if (!bResult)
		{
			RETAILMSG(1,(L"Failed to send IOCTL to NDIS device. Error = 0x%x\r\n", GetLastError()));
			return -1;
		}
		/* check that the value was set */
		NdisOIDQuery.ptcDeviceName = szDeviceName;
		NdisOIDQuery.Oid = OID_802_11_POWER_MODE;
		bResult = DeviceIoControl(hNdisDevice,
								 IOCTL_NDISUIO_QUERY_OID_VALUE,
								 &NdisOIDQuery,
								 sizeof(NdisOIDQuery),
								 &NdisOIDQuery,
								 sizeof(NdisOIDQuery),
								 &dwWritten,
								 NULL);
		if (!bResult)
		{
			RETAILMSG(1,(L"Failed to send IOCTL to NDIS device. Error = 0x%x\r\n", GetLastError()));
			return -1;
		}
		RETAILMSG(1,(L"Power Save was set %s.\r\n", (NdisOIDData.Data[0] == NdisOIDQuery.Data[0])?L"Correctly":L"Incorrectly"));
	}
	else
	{
		RETAILMSG(1,(L"Failed to open NDIS handle. Error = %d\r\n", GetLastError()));
		return -1;
	}

	return 0;
}

